--[[

Version 0.01 - Initial release of Concept code to wowace svn

Author : Auldare of EU Khadgar 
	
--]]

local L = LibStub("AceLocale-3.0"):GetLocale("AspectInspect")
local AceAddon = LibStub("AceAddon-3.0")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
AspectInspect = AceAddon:NewAddon("AspectInspect", "AceConsole-3.0", "AceEvent-3.0")
local REVISION = tonumber(("$Revision: 3 $"):match("%d+"))

AspectInspect.textures = {}
AspectInspect.borders = {}
AspectInspect.fonts = {}
AspectInspect.sounds = {}
AspectInspect.frameBackdrop ={
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	}

-------------------
-- Config details
-------------------

AspectInspect.defaults = {
	char = {
		message = "Welcome Home!",
		relativeTo = "UIParent",
		relativePoint = "CENTER",
		point = "CENTER",
		texture = "Blizzard",
		msgfont = "Friz Quadrata TT",
		msgfontsize = 24,
		msgfonteffect = "none",
		border = "None",
		barborder = "Blizzard Tooltip",
		xOffset = 0,
		yOffset = 0,
		fWidth = 300,
		fHeight = 175,
		scale = 1,
		debug = false,
	}
}

-----------------------------------------
-- Initialisation & Startup Routines
-----------------------------------------

function AspectInspect:OnInitialize()
	local AceConfigReg = LibStub("AceConfigRegistry-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")

	self.db = LibStub("AceDB-3.0"):New("AspectInspectDBPC", AspectInspect.defaults, "char")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("AspectInspect", self:GetOptions(), {"AspectInspect", "ai"} )
	media.RegisterCallback(self, "LibSharedMedia_Registered")
	
	-- Add the options to blizzard frame (add them backwards so they show up in the proper order
	self.optionsFrame = AceConfigDialog:AddToBlizOptions("AspectInspect","AspectInspect")
	self.optionsFrame[L["About"]] = LibStub("LibAboutPanel").new("AspectInspect", "AspectInspect")
	self.db:RegisterDefaults(self.defaults)
	local version = GetAddOnMetadata("AspectInspect","Version")
	self.version = ("AspectInspect v%s (r%s)"):format(version, REVISION)
	self:Print(self.version.." Loaded.")
end

function AspectInspect:OnDisable()
    -- Called when the addon is disabled
end

function AspectInspect:OnEnable()
	self:LibSharedMedia_Registered()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("UPDATE_BINDINGS")
end

function AspectInspect:LibSharedMedia_Registered()
	for k, v in pairs(media:List("statusbar")) do
		self.textures[v] = v
	end
	for k, v in pairs(media:List("border")) do
		self.borders[v] = v
	end
	for k, v in pairs(media:List("font")) do
		self.fonts[v] = v
	end
	for k, v in pairs(media:List("sound")) do
		self.sounds[v] = v
	end
end

----------------------
-- Event Routines
----------------------

function AspectInspect:PLAYER_ENTERING_WORLD()
	-- does stuff when player zones
end

function AspectInspect:UPDATE_BINDINGS()
--~ 	self:UpdateBindings()
end

